#include <lib/std.mi>

#define CUSTOM_VOL_VAR MiniVol
#include "customvol.m"

#define LAYER_VIS_VAR MainVis
#include "layervis.m"

Function setEqOnLayer(int eqValue, layer eqName);

Global Map VolMap, EQMap, LMap, RMap, CMap;

Global int isEQ, flashDir;
Global timer flashLight, timeTimer;

Class Layer HintLayer;
Class Text HintText;
Class Button HintButton;

Global HintLayer FVisLayer, LeftC, RightC, CenterC, Vol, VolGhost, EQonLayer, eq0,eq1,eq2,eq3,eq4,eq5,eq6,eq7,eq8,eq9,eq10, litpanel, litlight, BOrb, SOrb, COrb, FOrb;
Global HintButton EQOnoff, fVisOnoff;
Global HintText realTimer, BTimer, STimer, CTimer, tmptxt;

Global MouseReDir timerredir;
Global Slider opSlider;

opSlider.onSetPosition(int newpos) {
   BOrb.setalpha(newpos);
   SOrb.setalpha(newpos);
   COrb.setalpha(newpos);
   FOrb.setalpha(newpos);
}

opSlider.onSetFinalPosition(int newpos) {
   if (newpos == 0) { newpos = -1; }
   System.setPrivateInt("zygote", "orb_opacity", newpos);
}

System.onScriptUnloading() {
 _MainVisShutdown();
}

System.onScriptLoaded() {
  Layout mainnormal = getContainer("Main").getLayout("Normal");

  //Container skinconf = getContainer("skinconfig");
  Layout cwindow = getContainer("skinconfig").getLayout("Normal");

  opSlider = cwindow.getObject("opacity");
  tmptxt = cwindow.getObject("opacityname");

  Group fvisg = getContainer("Main").getLayout("Normal").getObject("main.fvis");

  fvisg.hide();

  LeftC = fvisg.getObject("leftc");
  RightC = fvisg.getObject("rightc");
  CenterC = fvisg.getObject("centerc");
  FVisLayer = fvisg.getObject("glass");

  LMap = new Map;
  LMap.loadMap("player.main.fvis.leftc.map");
  RMap = new Map;
  RMap.loadMap("player.main.fvis.rightc.map");
  CMap = new Map;
  CMap.loadMap("player.main.fvis.centerc.map");

  _MainVisInitLEFT(LeftC, LMap);
  _MainVisInitRIGHT(RightC, RMap);
  _MainVisInitCENTER(CenterC, CMap);
  _MainVisStart();
  _MainVisrefreshEQ.stop();

  litpanel = mainnormal.getObject("litpanel");
  litlight = mainnormal.getObject("litlight");

  Group orbgroup = getContainer("Main").getLayout("Normal").getObject("main.orb");
  Group sorbgroup = getContainer("Main").getLayout("shade").getObject("shade.orb");
  Group corbgroup = getContainer("Main").getLayout("Corner").getObject("corner.orb");

  BOrb = orbgroup.getObject("glass");
  SOrb = sorbgroup.getObject("glass");
  COrb = corbgroup.getObject("glass");
  FOrb = fvisg.getObject("glass");

  realtimer = orbgroup.getObject("realtextnumber");
  btimer = orbgroup.getObject("textnumber");
  stimer = sorbgroup.getObject("textnumber");
  ctimer = corbgroup.getObject("textnumber");

  timerredir = orbgroup.getObject("timerredir");

  timerredir.setRedirection(realtimer);

  realtimer.hide();
  timeTimer = new timer;
  timeTimer.setDelay(100);


  fVisOnoff = orbgroup.getObject("switch");

  Vol = orbgroup.getObject("volu");
  VolGhost = orbgroup.getObject("volufull");

  VolMap = new Map;
  VolMap.loadMap("player.main.volume.map");

  _MiniVolInit( Vol, VolGhost, VolMap);

  // eq-on-layer (tm)
  Group eqgroup = orbgroup.getObject("main.eq.on.layer");

  EQOnoff = eqgroup.getObject("switch");

  EQonLayer = eqgroup.getObject("eqlayer");
  
  eq0 = eqgroup.getObject("eq0");
  eq1 = eqgroup.getObject("eq1");
  eq2 = eqgroup.getObject("eq2");
  eq3 = eqgroup.getObject("eq3");
  eq4 = eqgroup.getObject("eq4");
  eq5 = eqgroup.getObject("eq5");
  eq6 = eqgroup.getObject("eq6");
  eq7 = eqgroup.getObject("eq7");
  eq8 = eqgroup.getObject("eq8");
  eq9 = eqgroup.getObject("eq9");
  eq10 = eqgroup.getObject("eq10");

  EQMap = new Map;
  EQMap.loadMap("player.main.eq.map");

  setEqOnLayer(- (System.getEqPreamp()) + 128, eq0);
  setEqOnLayer(- (System.getEqBand(1)) + 128, eq1);
  setEqOnLayer(- (System.getEqBand(2)) + 128, eq2);
  setEqOnLayer(- (System.getEqBand(3)) + 128, eq3);
  setEqOnLayer(- (System.getEqBand(4)) + 128, eq4);
  setEqOnLayer(- (System.getEqBand(5)) + 128, eq5);
  setEqOnLayer(- (System.getEqBand(6)) + 128, eq6);
  setEqOnLayer(- (System.getEqBand(7)) + 128, eq7);
  setEqOnLayer(- (System.getEqBand(8)) + 128, eq8);
  setEqOnLayer(- (System.getEqBand(9)) + 128, eq9);
  setEqOnLayer(- (System.getEqBand(10)) + 128, eq10);

  flashLight = new timer;
  flashLight.setDelay(50);
  
  if (getLeftVUMeter() != 0) {
    timeTimer.start();
  } 

  int orb_opacity = System.getPrivateInt("zygote", "orb_opacity", 0);
  
  if (orb_opacity == 0) {
   opSlider.setPosition(255);
   System.setPrivateInt("zygote", "orb_opacity", 255);
  }
  else {
   if (orb_opacity == -1) { orb_opacity = 0; }
   opSlider.setPosition(orb_opacity);
   BOrb.setalpha(orb_opacity);
   SOrb.setalpha(orb_opacity);
   COrb.setalpha(orb_opacity);
   FOrb.setalpha(orb_opacity);
  }
}

EQOnoff.onLeftClick() {
  Group orbgroup = getContainer("Main").getLayout("Normal").getObject("main.orb");
  Group eqgroup = orbgroup.getObject("main.eq.on.layer");

  int eqleft;

  eqleft = eqgroup.getLeft();
  if (eqleft < 150 ) {
    eqgroup.setTargetX(162);
    eqgroup.setTargetSpeed(1);

    eqgroup.gotoTarget();
  } else {
    eqgroup.setTargetX(81);
    eqgroup.setTargetSpeed(1);

    eqgroup.gotoTarget();
  }
}

fVisOnoff.onLeftClick() {
 Group fvisg = getContainer("Main").getLayout("Normal").getObject("main.fvis");
 fvisg.show();
 _MainVisrefreshEQ.start();
}

FVisLayer.onLeftButtonDown(int x, int y) {
 Group fvisg = getContainer("Main").getLayout("Normal").getObject("main.fvis");
 
 fvisg.hide();
 _MainVisrefreshEQ.stop();
}

System.onPlay() {
  litpanel.setTargetX(247);
  litpanel.setTargetY(54);
  litpanel.setTargetSpeed(1);

  litlight.setTargetA(255);
  litlight.setTargetSpeed(1);

  litpanel.gotoTarget();
  litlight.gotoTarget();

  timeTimer.start();
}

System.onPause() {
  flashDir = 1;
  flashLight.start();
}

System.onResume() {
  litlight.setAlpha(255);
  flashLight.stop();
}

System.onStop() {
  flashLight.stop();

  litpanel.setTargetX(238);
  litpanel.setTargetY(60);
  litpanel.setTargetSpeed(1);

  litlight.setTargetA(0);
  litlight.setTargetSpeed(1);

  litpanel.gotoTarget();
  litlight.gotoTarget();

  timeTimer.stop();
  BTimer.setText("....");
  STimer.setText("....");
  CTimer.setText("....");

}

timeTimer.onTimer() {
  string tmptimer;
  string tmp;

  tmptimer = realtimer.getText();

  if (strleft(tmptimer,1) == "-") tmptimer = strmid(tmptimer,1,-1);
  tmp = getToken(tmptimer, ":", 0);
  if (strlen(tmp) == 1) tmp = "0"+tmp;
  tmp = tmp + getToken(tmptimer, ":", 1);

  BTimer.setText( tmp );
  STimer.setText( tmp );
  CTimer.setText( tmp );
}

flashLight.onTimer() {
  int curalpha = litlight.getAlpha() + flashDir * 24;
  if (curalpha <= 96) { curalpha = 96; flashDir = -flashDir; }
  if (curalpha > 255) { curalpha = 255; flashDir = -flashDir; }
  litlight.setAlpha(curalpha);
}

EQOnLayer.onLeftButtonDown(int x, int y) {
  isEQ = 1;
}

EQOnLayer.onMouseMove(int x, int y) {
  int bandnumb;
  int eqvnumb;

  if (isEQ == 1) {
   x = x - EQOnLayer.getLeft();
   y = y - EQOnLayer.getTop();
   if ((x <= 84) && (x >= 0)) {
    if (y <= 0) y = 0;
    if (y >= 30) y = 30;

    bandnumb = x / 7;
    eqvnumb = y * 255 / 30;

    if (bandnumb == 0) {
     setEqOnLayer( eqvnumb, eq0);
     System.setEqPreamp( - (eqvnumb - 128));
    } 
    else {
     bandnumb = bandnumb - 1;
     System.setEqBand(bandnumb - 1, - (eqvnumb - 128));

     if (bandnumb == 1) setEqOnLayer( eqvnumb, eq1);
     if (bandnumb == 2) setEqOnLayer( eqvnumb, eq2);
     if (bandnumb == 3) setEqOnLayer( eqvnumb, eq3);
     if (bandnumb == 4) setEqOnLayer( eqvnumb, eq4);
     if (bandnumb == 5) setEqOnLayer( eqvnumb, eq5);
     if (bandnumb == 6) setEqOnLayer( eqvnumb, eq6);
     if (bandnumb == 7) setEqOnLayer( eqvnumb, eq7);
     if (bandnumb == 8) setEqOnLayer( eqvnumb, eq8);
     if (bandnumb == 9) setEqOnLayer( eqvnumb, eq9);
     if (bandnumb == 10) setEqOnLayer( eqvnumb, eq10);
    }
   }
  }
}

EQOnLayer.onLeftButtonUp(int x, int y) {
  isEQ = 0;
}

setEqOnLayer(int eqValue, layer eqName) {
  Region r = new Region;
  
  r.loadFromMap(EQMap, eqValue, 0);
  eqName.setRegion(r);
  
  delete r;
}