#include <lib/std.mi>

#define CUSTOM_VOL_VAR MiniVol
#include "customvol.m"

Global Map VolMap;

Global int flashDir;
Global timer flashLight;

Class Layer HintLayer;

Global HintLayer Vol, VolGhost, litpanel, litlight;

System.onScriptLoaded() {
  //Container main = getContainer("Main");
  Layout mainshade = getContainer("Main").getLayout("Shade");

  litpanel = mainshade.getObject("litpanel");
  litlight = mainshade.getObject("litlight");

  Group orbgroup = getContainer("Main").getLayout("shade").getObject("shade.orb");

  Vol = orbgroup.getObject("volu");
  VolGhost = orbgroup.getObject("volufull");

  VolMap = new Map;
  VolMap.loadMap("player.shade.volume.map");

  _MiniVolInit( Vol, VolGhost, VolMap);

  flashLight = new timer;
  flashLight.setDelay(50);

}

System.onPlay() {
  litpanel.setTargetX(134);
  litpanel.setTargetY(29);
  litpanel.setTargetSpeed(0.5);

  litlight.setTargetA(255);
  litlight.setTargetSpeed(0.5);

  litpanel.gotoTarget();
  litlight.gotoTarget();
}

System.onPause() {
  flashDir = 1;
  flashLight.start();
}

System.onResume() {
  litlight.setAlpha(255);
  flashLight.stop();
}

System.onStop() {
  flashLight.stop();

  litpanel.setTargetX(129);
  litpanel.setTargetY(32);
  litpanel.setTargetSpeed(0.5);

  litlight.setTargetA(0);
  litlight.setTargetSpeed(0.5);

  litpanel.gotoTarget();
  litlight.gotoTarget();
}

flashLight.onTimer() {
  int curalpha = litlight.getAlpha() + flashDir * 24;
  if (curalpha <= 96) { curalpha = 96; flashDir = -flashDir; }
  if (curalpha > 255) { curalpha = 255; flashDir = -flashDir; }
  litlight.setAlpha(curalpha);
}